config/routes.rb
Rails.application.routes.draw do
  ## OAUTH ##
  devise_scope :user do
    get "omniauth/franceconnect/callback" => "omniauth_callbacks#franceconnect"
  end

  devise_for :super_admins # necessary for helpers like super_admin_signed_in?
  devise_scope :super_admin do
    get "omniauth/github/callback" => "omniauth_callbacks#github"
  end

  ## ADMIN ##
  get "connexion_super_admins", to: "welcome#super_admin"

  delete "super_admins/sign_out" => "super_admins/sessions#destroy"

  namespace :super_admins do
    resources :agents do
      get "sign_in_as", on: :member
      post :invite, on: :member
    end
    resources :super_admins
    resources :organisations
    resources :services
    resources :motifs
    resources :territories
    resources :users do
      get "sign_in_as", on: :member
    end
    root to: "agents#index"

    authenticate :super_admin do
      match "/delayed_job" => DelayedJobWeb, anchor: false, via: %i[get post]
    end
  end
  get "super_admin", to: redirect("super_admins", status: 301)

  devise_scope :user do
    get "users/pending_registration" => "users/registrations#pending"
    get "invitation", to: "users/invitations#invitation", as: "invitations_landing"
  end

  ## APP ##
  devise_for :users,
             controllers: { registrations: "users/registrations", sessions: "users/sessions", passwords: "users/passwords", confirmations: "users/confirmations", invitations: "users/invitations" }

  namespace :users do
    resource :rdv_wizard_step, only: %i[new create]
    resources :rdvs, only: %i[index create show edit update] do
      member do
        get :creneaux
        put :cancel
      end
    end
    resource :user_name_initials_verification, only: %i[new create], controller: "user_name_initials_verification"
    post "file_attente", to: "file_attentes#create_or_delete"
  end
  resources :stats, only: :index
  get "stats/agents", to: "stats#agents", as: "agents_stats"
  get "stats/organisations", to: "stats#organisations", as: "organisations_stats"
  get "stats/rdvs", to: "stats#rdvs", as: "rdvs_stats"
  get "stats/users", to: "stats#users", as: "users_stats"
  get "stats/receipts", to: "stats#receipts", as: "receipts_stats"
  get "stats/:departement", to: "stats#index", as: "departement_stats"

  authenticate :user do
    get "/users/informations", to: "users/users#edit"
    patch "users/informations", to: "users/users#update"
    resources :relatives, except: %i[index show], controller: "users/relatives"
  end
  authenticated :user do
    get "/users/rdvs", to: "users/rdvs#index"
  end

  devise_for :agents, controllers: {
    invitations: "admin/invitations_devise", # only using the accept route here
    sessions: "agents/sessions",
    passwords: "agents/passwords",
  }

  devise_scope :agent do
    get "agents/edit" => "agents/registrations#edit", as: "edit_agent_registration"
    put "agents" => "agents/registrations#update", as: "agent_registration"
    delete "agents" => "agents/registrations#destroy", as: "delete_agent_registration"
    namespace :agents do
      resource :preferences, only: %i[show update]
    end
  end

  namespace :api do
    namespace :v1 do
      mount_devise_token_auth_for "AgentWithTokenAuth", at: "auth"
      resources :absences, except: %i[new edit]
      resources :agents, only: %i[index]
      resources :users, only: %i[create index show update] do
        get :invite, on: :member
        post :invite, on: :member
      end
      resources :user_profiles, only: [:create]
      resources :organisations, only: %i[index] do
        resources :users, only: %i[index show]
        resources :motifs, only: %i[index]
        resources :rdvs, only: %i[index]
      end

      resources :invitations, param: "token", only: [:show]
    end
  end

  resources :organisations, only: %i[new create]

  authenticate :agent do
    namespace "admin" do
      resources :territories, only: %i[update show] do
        scope module: "territories" do
          resources :agent_territorial_roles, only: %i[index new create destroy]
          resources :agent_territorial_access_rights, only: %i[update]
          resources :webhook_endpoints, except: %i[show]
          resources :agents
          resources :teams do
            collection do
              get :search
            end
          end
          resource :user_fields, only: %i[edit update]
          resource :rdv_fields, only: %i[edit update]
          resource :motif_fields, only: %i[edit update]
          resource :sms_configuration, only: %i[show edit update]
          resources :zone_imports, only: %i[new create]
          resources :zones, only: [:index] # exports only
          resources :sectors do
            resources :zones
            resources :sector_attributions, only: %i[new create destroy], as: :attributions
            delete "/zones" => "zones#destroy_multiple"
          end
          get "sectorisation_test" => "sectorisation_tests#search"
        end
      end

      # Routes pour les ressources du calendrier.
      # TODO trouver un meilleur nom pour éviter la nécessité de ce commentaire :)
      resources :agents, only: [], module: :agents do
        resources :plage_ouvertures, only: [:index]
        resources :rdvs, only: [:index]
        resources :absences, only: [:index]
      end

      resources :organisations do
        resources :plage_ouvertures, except: %i[index new]
        resources :agent_searches, only: :index, module: "creneaux"
        resources :slots, only: :index
        resources :lieux, except: :show
        resources :motifs
        resources :rdvs_collectifs, only: %i[index new create edit update] do
          collection do
            resources :motifs, only: [:index], as: :rdvs_collectif_motifs, controller: "rdvs_collectifs/motifs"
          end
        end
        resources :rdvs, except: [:new] do
          post :new_participation
          collection do
            post :export
          end
        end
        scope module: "organisations" do
          resource :setup_checklist, only: [:show]
          resources :stats, only: :index do
            collection do
              get :rdvs
              get :users
            end
          end
        end
        resources :users do
          member do
            post :invite
            get :link_to_organisation
          end
          collection do
            get :search
          end
          resources :referents, only: %i[index create destroy]
        end
        resources :absences, except: %i[index show new]
        resources :agent_roles, only: %i[edit update]
        resources :agent_agendas, only: %i[show] do
          put :toggle_displays, on: :member
        end
        resources :agents, only: %i[index destroy] do
          resources :absences, only: %i[index new]
          resources :plage_ouvertures, only: %i[index new]
          resources :stats, only: :index do
            collection do
              get :rdvs
              get :users
            end
          end
        end
        resources :invitations, only: [:index] do
          post :reinvite, on: :member
        end
        resource :merge_users, only: %i[new create]
        resource :rdv_wizard_step, only: [:new] do
          get :create
        end
        devise_for :agents, controllers: { invitations: "admin/invitations_devise" }, only: :invitations
        get "support", to: "static_pages#support"
      end

      resources :jours_feries, only: [:index]
    end
  end
  authenticated :agent do
    root to: "admin/organisations#index", as: :authenticated_agent_root, defaults: { follow_unique: "1" }
  end

  { contact: "contact", mds: "mds", accessibility: "accessibility" }.each do |k, v|
    get v => "static_pages##{k}"
  end

  ## Shorten urls for SMS

  get "r", to: redirect("users/rdvs", status: 301), as: "rdvs_short"

  get "r/:id", to: (redirect do |path_params, req|
    query_params = format_redirect_params(req.params)
    "users/rdvs/#{path_params[:id]}#{query_params}"
  end), as: "rdv_short"

  get "prdv", to: (redirect do |_path_params, req|
    query_params = format_redirect_params(req.params)
    "prendre_rdv#{query_params}"
  end), as: "prendre_rdv_short"

  get "r/:id/cr", to: (redirect do |path_params, req|
    query_params = format_redirect_params(req.params)
    "users/rdvs/#{path_params[:id]}/creneaux#{query_params}"
  end), as: "creneaux_users_rdv_short"

  def format_redirect_params(params)
    # we rename the short parameter tkn
    params[:invitation_token] ||= params.delete(:tkn) if params[:tkn]
    params.delete(:id) # id is passed through path_params
    params.values.any? ? "?#{params.to_query}" : ''
  end

  ##

  get "accueil_mds" => "welcome#welcome_agent"
  post "/" => "welcome#search"
  get "departement/:departement", to: "welcome#welcome_departement", as: "welcome_departement"
  post "departement/:departement" => "welcome#search_departement"
  get "departement/:departement/:service", to: "welcome#welcome_service", as: "welcome_service"
  resources :lieux, only: %i[index show]
  root "welcome#index"

  get "/prendre_rdv", to: "search#search_rdv"

  # rubocop:disable Style/FormatStringToken
  # temporary route after admin namespace introduction
  get "/organisations/*rest", to: redirect('admin/organisations/%{rest}')
  # old agenda rule was bookmarked by some agents
  get "admin/organisations/:organisation_id/agents/:agent_id", to: redirect("/admin/organisations/%{organisation_id}/agent_agendas/%{agent_id}")
  # rubocop:enable Style/FormatStringToken

  # LetterOpener
  mount LetterOpenerWeb::Engine, at: "/letter_opener" if Rails.env.development?
end

app/controllers/admin/lieux_controller.rb
# frozen_string_literal: true

class Admin::LieuxController < AgentAuthController
  respond_to :html, :json

  def index
    @lieux = policy_scope(Lieu).not_single_use.ordered_by_name.page(params[:page])
  end

  def new
    @lieu = Lieu.new(organisation_id: current_organisation.id)
    authorize(@lieu)
  end

  def create
    @lieu = Lieu.new(organisation_id: current_organisation.id)
    @lieu.assign_attributes(lieu_params)
    @lieu.availability = :enabled # Always enable new Lieux

    authorize(@lieu)
    if @lieu.save
      flash.notice = "Le lieu a été créé."
      redirect_to admin_organisation_lieux_path(@lieu.organisation)
    else
      render :new
    end
  end

  def edit
    @lieu = policy_scope(Lieu).find(params[:id])
    authorize(@lieu)
  end

  def update
    @lieu = Lieu.find(params[:id])
    authorize(@lieu)
    if @lieu.update(lieu_params)
      flash[:notice] = "Le lieu a été modifié."
      redirect_to admin_organisation_lieux_path(@lieu.organisation)
    else
      render :edit
    end
  end

  def destroy
    @lieu = Lieu.find(params[:id])
    authorize(@lieu)
    if @lieu.destroy
      flash[:notice] = "Le lieu a été supprimé."
      redirect_to admin_organisation_lieux_path(@lieu.organisation)
    else
      render :edit
    end
  end

  private

  def lieu_params
    params.require(:lieu).permit(:name, :address, :phone_number, :enabled, :latitude, :longitude)
  end
end

app/controllers/lieux_controller.rb
# frozen_string_literal: true

class LieuxController < ApplicationController
  before_action \
    :redirect_if_search_params_absent,
    :set_lieu_variables,
    :redirect_if_user_offline_and_motif_follow_up,
    :redirect_if_no_matching_motifs
  after_action :allow_iframe

  def index
    @lieux = Lieu
      .with_open_slots_for_motifs(@matching_motifs)
      .includes(:organisation)
      .sort_by { |lieu| lieu.distance(@latitude.to_f, @longitude.to_f) }
    @next_availability_by_lieux = @lieux.to_h do |lieu|
      [lieu.id, creneaux_search_for(lieu).next_availability]
    end
  end

  def show
    start_date = params[:date]&.to_date || Time.zone.today
    @date_range = start_date..(start_date + 6.days)
    @lieu = Lieu.find(params[:id])
    @query.merge!(lieu_id: @lieu.id)
    @next_availability = nil

    if follow_up_motif? && current_user && current_user.agents.empty?
      @referent_missing = t(".referent_missing", phone_number: @lieu.organisation.phone_number)
      @creneaux = []
    else
      creneaux_search = creneaux_search_for(@lieu, @date_range)
      @creneaux = creneaux_search.creneaux
      @next_availability = creneaux_search.next_availability if @creneaux.empty?
    end

    @max_booking_delay = @matching_motifs.maximum("max_booking_delay")

    respond_to do |format|
      format.html
      format.js
    end
  end

  private

  def redirect_if_search_params_absent
    return if params[:search].present?

    redirect_to root_path, flash: { error: "Les paramètres de recherche n'ont pas été transmis correctement" }
  end

  def redirect_if_user_offline_and_motif_follow_up
    return if !follow_up_motif? || current_user.present?

    redirect_to new_user_session_path, flash: { notice: I18n.t("motifs.follow_up_need_signed_user", motif_name: @matching_motifs.first.name) }
  end

  def redirect_if_no_matching_motifs
    return if @matching_motifs.any?

    redirect_to root_path, flash: { error: "Une erreur s'est produite, veuillez recommencer votre recherche" }
  end

  def follow_up_motif?
    @matching_motifs.first&.follow_up?
  end

  def creneaux_search_for(lieu, date_range = nil)
    Users::CreneauxSearch.new(
      user: current_user,
      motif: @matching_motifs.where(organisation: lieu.organisation).first, # there can be only one
      lieu: lieu,
      date_range: date_range,
      geo_search: @geo_search
    )
  end

  def search_params
    params.require(:search).permit(:departement, :where, :service, :motif_name_with_location_type, :longitude, :latitude, :city_code, :street_ban_id)
  end

  def set_lieu_variables
    @query = search_params.to_hash
    @departement = search_params[:departement]
    @motif_name_with_location_type = search_params[:motif_name_with_location_type]
    @where = search_params[:where]
    @service_id = search_params[:service]
    @city_code = search_params[:city_code]
    @street_ban_id = search_params[:street_ban_id]
    @service = Service.find(@service_id)
    @geo_search = Users::GeoSearch.new(
      departement: @departement,
      city_code: @city_code,
      street_ban_id: @street_ban_id.presence
    )
    searchable_motifs = @geo_search.available_motifs.where(service: @service)
    @unique_motifs_by_name_and_location_type = searchable_motifs.uniq { [_1.name, _1.location_type] }
    @matching_motifs = searchable_motifs.search_by_name_with_location_type(@motif_name_with_location_type)
    @latitude = search_params[:latitude]
    @longitude = search_params[:longitude]
  end
end

app/controllers/super_admins/lieux_controller.rb
# frozen_string_literal: true

module SuperAdmins
  class LieuxController < SuperAdmins::ApplicationController
    # To customize the behavior of this controller,
    # you can overwrite any of the RESTful actions. For example:
    #
    # def index
    #   super
    #   @resources = Agent.
    #     page(params[:page]).
    #     per(10)
    # end

    # Define a custom finder by overriding the `find_resource` method:
    # def find_resource(param)
    #   Agent.find_by!(slug: param)
    # end

    # See https://administrate-prototype.herokuapp.com/customizing_controller_actions
    # for more information
  end
end

app/helpers/lieux_helper.rb
# frozen_string_literal: true

module LieuxHelper
  def unavailability_tag(lieu)
    return if lieu.nil?
    return if lieu.availability.nil?
    return if lieu.enabled?

    tag.span(lieu.human_attribute_value(:availability),
             class: class_names("badge",
                                "badge-danger" => lieu.disabled?,
                                "badge-info" => lieu.single_use?))
  end
end

app/views/admin/lieux/_lieu.html.slim
- nb_rdv = policy_scope(Rdv).for_today.merge(lieu.rdvs).count
tr id="lieu_#{lieu.id}"
  td
    = lieu.name
    = unavailability_tag(lieu)
  td= lieu.address
  td= lieu.phone_number
  td= link_to nb_rdv > 0 ? nb_rdv : "aucun", admin_organisation_rdvs_path(current_organisation, lieu_id: lieu.id, start: Time.zone.now.beginning_of_day, end: Time.zone.now.end_of_day )
  td
    - if policy([:agent, lieu]).edit? || policy([:agent, lieu]).destroy?
      .d-flex
        - if policy([:agent, lieu]).edit?
          div.mr-3= link_to edit_admin_organisation_lieu_path(current_organisation, lieu),
                  title: t("helpers.edit") do
            i.fa.fa-edit
        - if policy([:agent, lieu]).destroy?
          div= link_to admin_organisation_lieu_path(current_organisation, lieu),
                  title: t("helpers.delete"),
                  method: :delete,
                  data: { confirm: "Confirmez-vous la suppression de ce lieu ?"} do
            i.fa.fa-trash-alt

app/views/admin/lieux/_lieu_fields.html.slim
/ This partial is used for the form in Lieu#new and Lieu#edit, as well as and RdvWizardSteps#step3 (as a nested form)
  TODO: We might want to allow admins to create a new Lieu for a Rdv, and immediately save it in the organisation lieu.
  In this scenario, having this common partial (instead of a separate partial for the nested form) will be useful.

- is_new_form = f.object_name == "lieu" && f.object.new_record?
- is_edit_form = f.object_name == "lieu" && f.object.persisted?
- is_nested_form = f.object_name != "lieu"

/ New and Edit
- if is_new_form || is_edit_form
  = render "model_errors", model: f.object

/ All forms
= f.input :name, required: true
- unless is_nested_form
  = f.input :phone_number
= f.input :address, input_html: { class: "places-js-container" }
= f.hidden_field :latitude
= f.hidden_field :longitude

/ Edit only
- if is_edit_form
  = f.input :enabled

/ New and Edit
- if is_new_form || is_edit_form
  - lieu_is_referenced = @lieu.plage_ouvertures.any? || @lieu.rdvs.any?
  .row
    - if is_edit_form
      .col.text-left
        - if lieu_is_referenced
          = button_tag t("helpers.delete"), type: "button", disabled: true, class: "btn btn-outline-danger"
        - else
          = link_to t("helpers.delete"), admin_organisation_lieu_path(@lieu.organisation, @lieu), method: :delete, class: "btn btn-outline-danger", data: { confirm: t(".confirm_delete") }
    .col.text-right
      = link_to t("helpers.cancel"), admin_organisation_lieux_path(@lieu.organisation), class: "btn btn-link"
      = f.button :submit
  .row.mt-3
    .col
      - if lieu_is_referenced
        .alert.alert-info
          h5.alert-heading =t(".referenced_lieu")
          - if @lieu.plage_ouvertures.any?
            p= t(".referenced_in_plage_ouvertures")
          - if @lieu.rdvs.any?
            p
              = link_to t(".referenced_in_rdvs_1"), admin_organisation_rdvs_path(current_organisation, lieu_id: @lieu.id)
              =< t(".referenced_in_rdvs_2")

app/views/admin/lieux/edit.html.slim
- content_for(:menu_item) { "menu-lieux" }

- content_for :title do
  | Modifier le lieu

- content_for :breadcrumb do
  ol.breadcrumb.m-0
    li.breadcrumb-item
      = link_to "Vos lieux", admin_organisation_lieux_path(current_organisation)
    li.breadcrumb-item.active= @lieu.name

.row.justify-content-center
  .col-md-8
    .card
      .card-body
        = simple_form_for [:admin, @lieu.organisation, @lieu] do |f|
          = render "lieu_fields", f: f

= render "admin/versions/resource_versions_row", resource: @lieu

app/views/admin/lieux/index.html.slim
- content_for(:menu_item) { "menu-lieux" }

- content_for :title do
  | Vos lieux de consultation

- if current_agent_can?(:create, Lieu)
  - content_for :breadcrumb do
    = link_to "Ajouter un lieu", new_admin_organisation_lieu_path(current_organisation), class: "btn btn-outline-primary"

.card
  .card-body
    - if @lieux.any?
      table.table
        thead
          tr
            th Nom
            th Adresse
            th Téléphone
            th RDV aujourd'hui
            th Actions
        tbody
          = render @lieux
      .d-flex.justify-content-center= paginate @lieux, theme: "twitter-bootstrap-4"
    - else
      .row.justify-content-md-center
        .col-md-6.text-center.my-5
          p.mb-2.lead Vous n'avez pas encore ajouté de lieu de consultation.
          p Les lieux sont les endroits où sont réalisés les RDV. L'adresse du lieu est contenue dans les notifications envoyées à l'usager.
          span.fa-stack.fa-4x
            i.fa.fa-circle.fa-stack-2x.text-primary
            i.fa.fa-building.fa-stack-1x.text-white

    - if current_agent_can?(:create, Lieu)
      .text-center
        = link_to "Ajouter un lieu", new_admin_organisation_lieu_path(current_organisation), class: "btn btn-primary"

app/views/admin/lieux/new.html.slim
- content_for(:menu_item) { "menu-lieux" }

- content_for :title do
  | Nouveau lieu

- content_for :breadcrumb do
  ol.breadcrumb.m-0
    li.breadcrumb-item
      = link_to "Vos lieux", admin_organisation_lieux_path(current_organisation)
    li.breadcrumb-item.active Nouveau lieu

.row.justify-content-center
  .col-md-8
    .card
      .card-body
        = simple_form_for [:admin, @lieu.organisation, @lieu] do |f|
          = render "lieu_fields", f: f